/*
 * ******************************************************************************************
 *
 * File     : apb_sd_host_dev.h
 * Author	  : GOWIN
 * Function	: Device definition of APB SD Host
 *
 * ******************************************************************************************
 */

#ifndef __APB_SD_HOST_DEV_H__
#define __APB_SD_HOST_DEV_H__


#ifdef __cplusplus
extern "C" {
#endif


// Includes ---------------------------------------------------------------------------------
#include "apb_sd_host.h"
#include "GOWIN_M1.h"


// Defines ----------------------------------------------------------------------------------

/*************************************************************************************
 * An APB SD Host device "APB SD1" is defined as a user template.
 *************************************************************************************/

#define APB_SD1_BASE						APB_M1																		// APB SD1 address defines
#define APB_SD1									((APB_SD_Host_RegDef*) APB_SD1_BASE)			// APB SD1 register defines

#define IRQ_SD_CMD_SOURCE				EXTINT_0_IRQn															// APB SD1 command interrupt source
#define IRQ_SD_DATA_SOURCE			EXTINT_1_IRQn															// APB SD1 data interrupt source

#define sd_cmd_irq_handler			EXTINT_0_Handler													// APB SD1 command interrupt handler
#define sd_data_irq_handler			EXTINT_1_Handler													// APB SD1 data interrupt handler


#ifdef __cplusplus
}
#endif


#endif	/* __APB_SD_HOST_DEV_H__ */
