/*
 * ******************************************************************************************
 *
 * File     : apb_sd_host_driver.h
 * Author   : GOWIN
 * Function : Driver definition of APB SD Host
 *
 * ******************************************************************************************
 */

#ifndef __APB_SD_HOST_DRIVER_H__
#define __APB_SD_HOST_DRIVER_H__


#ifdef __cplusplus
extern "C" {
#endif


// Includes ---------------------------------------------------------------------------------
#include "apb_sd_host.h"


// Defines ----------------------------------------------------------------------------------

// Software reset
void apb_sd_host_reset(APB_SD_Host_RegDef* sd_host, sd_reset_type reset_state);

// Configure clock
void apb_sd_host_clock_config(APB_SD_Host_RegDef* sd_host, sd_clk_div_type clk_div);

// Configure bus width
void apb_sd_host_bus_width_config(APB_SD_Host_RegDef* sd_host, sd_bus_width_type width);

// Configure command
void apb_sd_host_command_config(APB_SD_Host_RegDef* sd_host, sd_command_struct_type *command_struct);

// Get response
unsigned int apb_sd_host_response_get(APB_SD_Host_RegDef* sd_host, sd_rsp_index_type reg_index);

// Configure data
void apb_sd_host_data_config(APB_SD_Host_RegDef* sd_host, sd_data_struct_type *data_struct);

// Write data
void apb_sd_host_data_write(APB_SD_Host_RegDef* sd_host, unsigned int *w_data);

// Read data
void apb_sd_host_data_read(APB_SD_Host_RegDef* sd_host, unsigned int *r_data);

// Enable interrupt
void apb_sd_host_interrupt_enable(APB_SD_Host_RegDef* sd_host, sd_interrupt_type type, unsigned char int_opt,  unsigned char new_state);

// Get interrupt status
unsigned char apb_sd_host_interrupt_status_get(APB_SD_Host_RegDef* sd_host, sd_interrupt_type type, unsigned char flag);

// Clear interrupt status
void apb_sd_host_interrupt_status_clear(APB_SD_Host_RegDef* sd_host, sd_interrupt_type type, unsigned int flag);

// Get FIFO status
unsigned char apb_sd_host_fifo_status_get(APB_SD_Host_RegDef* sd_host, sd_fifo_type fifo_type);


#ifdef __cplusplus
}
#endif


#endif	/* __APB_SD_HOST_DRIVER_H__ */
